import callback, _global1, _global2, sys, MLab
def wrap(x):
    xargs = list(extra_args)
    xargs.insert(0, x)
    return apply(funct, tuple(xargs))

def Gmin(f, mmin, mmax, xargs=(), smooth=1, trace=None, nsampl=300, nsel=10, nsig=10):
    " [fmin, xmin, nfeval] = Gmin(f, mmin, mmax, xargs=(), smooth=1, trace=None, nsampl=300, nsel=10, nsig=10) returns the most likely global minimum with the number of evaluations in feval. \n mmin, mmax are bounds for x. Python function f accepts an array x and possible xargs as its arguments, and return a double value " 
    
    mmin = MLab.array(mmin)
    mmax = MLab.array(mmax)
    nparm = len(mmin)
    if len(mmax) != nparm: 
        print 'number of mmin, mmax mismatch\n'
        return None
    mmin_ = MLab.zeros(nparm+1, 'd')
    mmin_[1:] = mmin
    mmax_ = MLab.zeros(nparm+1, 'd')
    mmax_[1:] = mmax
    m = 1 # not used
    x0 = MLab.zeros((nparm+1,21), 'd')
    f0 = MLab.zeros(21, 'd')
    if trace: dump = sys.stdout
    else: dump = open("/dev/null", "w")

    # make a callback
    if len(xargs) == 0:
        cb = callback.callback(f, 'GLOBAL')
    else:
        global funct, extra_args
        funct=f; extra_args = xargs
        cb = callback.callback(wrap, 'GLOBAL')

    # rtv=0 success, nc number of minima, nfeval number of total evals
    if smooth:
        [rtv, nc, nfeval] = _global1.GLOBAL(cb, mmin_, mmax_, nparm, m, nsampl, nsel, dump, nsig, x0, f0)
    else:
        [rtv, nc, nfeval] = _global2.GLOBAL(cb, mmin_, mmax_, nparm, m, nsampl, nsel, dump, nsig, x0, f0)

    # cleanup and return
    if not trace: dump.close()
    if rtv != 0:
        print 'Gmin failed\n' 
        return None
    # all the nc local minima are in fmin, xmin in an increasing order
    fmin = f0[1:nc+1]
    xmin = MLab.transpose(x0[1:, 1:nc+1])
    # only returns the smallest
    xmin0 = xmin[0]
    if nparm == 1: xmin0 = xmin0[0] 
    return [fmin[0], xmin0, nfeval]
