/* Modified by M Xu 3/20/99 */
#include "Python.h"
#define CALLBACK_MODULE
#include "callback.h"
#include "arrayobject.h" /* for import_array() */
#define ERRORRETURN(mes)  {PyErr_SetString(ErrorObject,(mes)); return NULL;}
#define TRY(E) if( ! (E)) return NULL

static PyObject *ErrorObject = NULL;

static PyObject *CallbackError()
{  
    if (! ErrorObject)
	ErrorObject = PyString_FromString("CallbackError");
    Py_INCREF(ErrorObject);
    return ErrorObject;
}

static PyObject *setFn(PyObject *self, PyObject *args)
{
    PyObject *a;
    int i;
    /* No allocation is needed for nm */ 
    TRY(PyArg_ParseTuple(args, "Oi", &a, &i));
    if (i<0 || i>=BUF_SIZE) return NULL;
    Py_INCREF(a);
    userfn[i]->pyfn = a;
    return a;
}

static struct PyMethodDef _callback_module_methods[] = {
    {"setFn", setFn, 1},
    { NULL,NULL,0}
};

extern void init_callback()
{ 
    PyObject *m, *ufn, *d;
    static void *callback_API[1];
    PyObject *c_api_object;
    
    m = Py_InitModule("_callback", _callback_module_methods);
    /* for NumPy array */
    import_array();
    
    d = PyModule_GetDict(m);
    ErrorObject = CallbackError();
    PyDict_SetItemString(d, "CallbackError", ErrorObject);
    ufn = userfn_NameList();
    PyDict_SetItemString(d, "UserFunctions", ufn);
    Py_DECREF(ufn);
    
    callback_API[0] = (void *)getCallbackFn;
    c_api_object = PyCObject_FromVoidPtr((void *)callback_API, NULL);
    PyDict_SetItemString(d, "_C_API", c_api_object);
    Py_DECREF(c_api_object);
}
