# Written by Doug Heisterkamp,  drh@cse.unl.edu
# Last modified: 11/12/96
from Numeric import *
from string import *
import callback
import dodr

# function atrans returns a contiguous array that is the transpose of it's
# argument.  
#
# Since it is use to make the C style arrays compatible with use in fortran
# functions.  Not effiecient, since the arrays could be initialized in a 
# fortran compatible data, but I used it here to avoid confusion with
# the differnces in array indexing. 

def atrans(a): return array(transpose(a))


def PyFCN(n,m,np,nq,ldn,ldm,ldnp,beta,xplusd,ifixb,ifixx,ldifx,ideval,f,fjacb,fjacd,istop):
	if (beta[0] > 0.0):
		istop[0] = 1
		return None
	else:
		istop[0] = 0
	if (ideval%10)>= 1:
		for l in xrange(nq):
			for i in xrange(n):
				f[l,i] = beta[2]*(xplusd[0,i] -beta[0])**2  +2* beta[3]*(xplusd[0,i]-beta[0])*(xplusd[1,i]-beta[1])  + beta[4]*(xplusd[1,i]-beta[1])**2 -1.0 
	return None



# Initializing Data before call to dodr
maxm,maxn,maxnp,maxnq = 5,25,5,2
ldwd,ldwe,ldx,ldy,ld2wd,ld2we = 1,1,maxn,maxn,1,1
lwork=18 + 11*maxnp + maxnp**2 + maxm + maxm**2 + 4*maxn*maxnq + 6*maxn*maxm + 2*maxn*maxnq*maxnp +  2*maxn*maxnq*maxm + maxnq**2 + 5*maxnq + maxnq*(maxnp+maxm) + ldwe*ld2we*maxnq
liwork=20+maxnp+maxnq*(maxnp+maxm)
 
# Instead of writing to file, write to standard out (the default)
#lunerr = 9
#lunrpt = 9
#open(unit=9,file='report2')

tempf = open("DATA2","r")
templ = map(lambda x:map(lambda y:atof(y),split(x)),tempf.readlines())
n,m,np,nq = tuple(map(int,templ[0]))
#n=#of obs, m=#of elements in x, np=#of function parameters, nq=# of response
beta = array(templ[1],Float)
#beta = array of function parameters
y = atrans(zeros((ldy,maxnq),Float))
# y = response variables --> in the implicit model, y is NOT reference

# The size maxm is greater than the size of the data.  Need to place it
#inside the array x.
#x(ldx,m) = array of observed values
x0 = zeros((ldx,maxm),Float)
x1 = array(templ[2:],Float)
x0[:x1.shape[0],:x1.shape[1]] = x1
x = atrans(x0)

we = atrans(zeros((ldwe,ld2we,maxnq),Float))
#Note: for implicit model only the first element is every referenced
we[0,0,0] = -1.0
wd = atrans(zeros((ldwd,ld2wd,m),Float))
wd[0,0,0] = -1.0

#  SPECIFY TASK: IMPLICIT ORTHOGONAL DISTANCE REGRESSION
#                WITH FORWARD FINITE DIFFERENCE DERIVATIVES
#                COVARIANCE MATRIX CONSTRUCTED WITH RECOMPUTED DERIVATIVES
#                DELTA INITIALIZED TO ZERO
#                NOT A RESTART
job = 00001

iprint = -1
lunerr = -1
lunrpt = -1

work = zeros(lwork,Float)
iwork = zeros(liwork,Int)
info = 0

# Use this to call the Fortran subroutine instead of the Python one.
#fnindex = callback.callback("fcn2_")

# Set the Python function for use in dodr
fnindex = callback.callback(PyFCN,"dodr")

res = dodr.dodr(fnindex,n,m,np,nq,beta,y,ldy,x,ldx,we,ldwe,ld2we,wd,ldwd,ld2wd, job, iprint, lunerr, lunrpt, work, lwork, iwork, liwork, info)

print res


#Note: beta contains the final results of the parameter estimation.
