      SUBROUTINE BRASI
C
C  BRASI  PERFORMS THE SELECTION PROCESS FOR THE TRAJECTORIES
C  BRASI  - UPDATES THE DATA ABOUT THE PAST TRAJECTORIES
C         - ASKS FOR THE TRAJECTORY-SELECTION ORDERING BY CALLING THE
C              SUBROUTINE  ORDER
C         - DISCARDS ONE OF THE TRAJECTORIES
C         - PERFORMS BRANCHING ON ONE OF THE REMAINING TRAJECTORIES
C         - MOVES THE DATA OF THE UNPERTURBED CONTINUATION
C              TO THE POSITION OF THE PERTURBED CONTINUATION
C         - CALLS THE SUBROUTINE  COMPAS  TO EXAMINE DATA ABOUT PAST
C              HISTORY OF THE TRAJECTORIES AND DISCARD IRRILEVANT DATA
C
      DOUBLE PRECISION DFAC,DLEPMX,DLFACL
      DOUBLE PRECISION EFAC,EPSMAX,FACG
      DOUBLE PRECISION CHAOS
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
C
      DATA FACG/10.D0/
      DATA EFAC/.5D0/
      DATA DFAC/1.D3/
      DATA EPSMAX/1.D15/
      DATA DLFACL /0.301029995663981194D0/
      DATA DLEPMX /25.D0/
C
C UPDATE PAST HISTORY DATA
C
      DO 10 ID = 1,NTRAJ
         VMVT(ID,NTRAJR) = VMCOR(ID)
         ISVT(ID,NTRAJR) = ID
  10     CONTINUE
C
C OBTAIN TRAJECTORY-SELECTION ORDERING
C
      CALL ORDER(IP,IM,IU)
C
C DECIDE WHICH TRAJECTORY IS TO BE BRANCHED
C
      IF(MOD(KGEN,INKPBR).EQ.KPBR0)IM = IP
C
C PERFORM BRANCHING
C
      DO 20 IC = 1,NDIM
         X(IC,IU) = X(IC,IM)
  20     CONTINUE
      H(IU) = H(IM)
      IE(IU) = IE(IM)
      DO 30 IT = 1,NTRAJR
         ISVT(IU,IT) = ISVT(IM,IT)
         VMVT(IU,IT) = VMVT(IM,IT)
  30     CONTINUE
      EPS(IU) = EPS(IM)
      DX(IU) = DX(IM)
      VCOR(IU) = VCOR(IM)
      DO 40 ID = 1,NTRAJ
         VMCOR(ID) = VCOR(ID)
  40     CONTINUE
C
C UPDATE PAST-HISTORY-DATA MATRICES
C
      CALL COMPAS
C
C UPDATE SCALING DATA
C
      CALL MOVSCA(IU,IM)
C
C UPDATE NOISE COEFFICIENT VALUES
C
      IF (EPS(IU).LE.0.D0) GO TO 50
      IF(IFEP.EQ.2)
     1    EPS(IU) = EPS(IU)*FACG**(CHAOS(0)-EFAC)
      IF(IFEP.EQ.1)
     1    EPS(IU) = FACG**(DMIN1(DLEPMX,
     1    DLOG10(EPS(IU))+(CHAOS(-1)-EFAC)*DLFACL))
      EPS(IU) = DMIN1(EPS(IU),EPSMAX)
  50  CONTINUE
C
C UPDATE MAGNITUDE OF SPATIAL DISCRETIZATION INCREMENT
C
      DX(IU) = DX(IU)*DFAC**CHAOS(0)
      RETURN
      END
