      DOUBLE PRECISION FUNCTION FUNCT0(N,XX)
C
C  FUNCT0  IS CALLED  WHENEVER THE VALUE OF THE FUNCLION  F  IS REQUIRED
C  IN THE NUMERICAL INTEGRATION PROCESS.
C  THE FUNCTION  FUNCT0
C   - RESCALES THE VARIABLES BY CALLING THE SUBROUTINE  VARSCA
C   - CALLS THE SUBROUTINE  RANGE  TO TAKE CARE OF THE CASES WHERE THE
C      CURRENT POINT  X  IS OUTSIDE A GIVEN ADMISSIBLE REGION
C   - CALLS THE USER-SUPPLIED FUNCTION  FUNCT  TO ACTUALLY COMPUTE THE
C      VALUE OF  F
C   - POSSIBLY CALLS THE SUBROUTINE  STOOPT  TO UPDATE THE CURRENT
C        BEST MINIMUM FUNCTION VALUE  FOPT  AND THE CORRESPONDING
C        MINIMIZER  XOPT
C
      DOUBLE PRECISION XX
      DOUBLE PRECISION F,R,XS
      DOUBLE PRECISION FUNCT
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
      DIMENSION XX(N)
      DIMENSION XS(100)
C
      DO 10 IX = 1,N
         XS(IX) = XX(IX)
  10     CONTINUE
C
C DESCALE  X-VARIABLES
      CALL VARSCA(N,XS)
C
C CONSTRAIN THE  X-VARIABLES WITHIN BOUNDS
      CALL RANGE(N,XS,XRMIN,XRMAX,R)
C
C COMPUTE THE FUNCTION VALUE...
      F = FUNCT(N,XS)+R
C
C ... AND POSSIBLY UPDATE THE BEST CURRENT MINIMUM
      IF(F.LT.FOPT)CALL STOOPT(N,XS,F)
      FUNCT0 = F
      NCF = NCF+1
C
      RETURN
      END
