      SUBROUTINE INIT(NX,X0,H0,EPS0,DX0,IRAND,F,N1,N2,N3,N4
     1    ,INH,IFE,XRI,XRA,IT)
C
C  INIT  PERFORMS THE INITIALIZATION OF THE FIRST TRIAL.
C  THE PART OF THE INITIALIZATION WHICH IS COMMON ALSO TO THE TRIALS
C  FOLLOWING THE FIRST ONE IS PERFORMED BY CALLING THE SUBROUTINE
C  REINIT.
C
      DOUBLE PRECISION X0,H0,EPS0,DX0,F,XRI,XRA
      DOUBLE PRECISION FUNCT
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
      DIMENSION X0(NX),XRI(NX),XRA(NX)
      DATA NPMAX/100/
      DATA NTRAJM/20/
      DATA NTRAJ0/7/
      DATA INKPB0/10/
      DATA KPBR00/3/
C
C CHECK PARAMETER VALUES
C
      IT = 0
      IF (NX.GT.NPMAX.OR.NX.LT.1.OR.H0.LE.0.D0.OR.EPS0.LE.0.D0
     1    .OR.DX0.LE.0.D0) IT = -99
      IF (IT.EQ.(-99)) RETURN
C
C INITIALIZE SOME VARIABLES
C
      INHP = INH
      DO 10 IX = 1,NX
         XRMIN(IX) = XRI(IX)
         XRMAX(IX) = XRA(IX)
  10     CONTINUE
      CALL NOSCA
      NTRAJ = N1
      IF(NTRAJ.EQ.0)NTRAJ = NTRAJ0
      NTRAJ = MIN0(NTRAJ,NTRAJM)
      NTRAJ = MAX0(NTRAJ,3)
      N1 = NTRAJ
      ISEGBR = N2
      IF(ISEGBR.EQ.0)ISEGBR = (1+NTRAJ)/2
      ISEGBR = MIN0(ISEGBR,NTRAJ)
      ISEGBR = MAX0(ISEGBR,1)
      N2 = ISEGBR
      INKPBR = N3
      IF(INKPBR.EQ.0)INKPBR = INKPB0
      N3 = INKPBR
      KPBR0 = N4
      IF(KPBR0.EQ.0)KPBR0 = KPBR00
      KPBR0 = MOD(KPBR0,INKPBR)
      N4 = KPBR0
      NDIM = NX
      NTRAJR = NTRAJ-1
      NCF = 1
      F = FUNCT(NX,X0)
      CALL STOOPT(NX,X0,F)
      DO 20 ID = 1,NTRAJ
         H(ID) = H0
         DX(ID) = DX0
  20     CONTINUE
C
C INITIALIZE REMAINING VARIABLES
C
      CALL REINIT(NX,X0,EPS0,IRAND,F,IFE)
C
      RETURN
      END
