      SUBROUTINE PERIOD
C
C  PERIOD  IS CALLED BY SUBROUTINE  GENEVA  TO PERFORM THE GENERATION
C  OF THE TRAJECTORY SEGMENTS.
C  PERIOD  - COMPUTES THE DURATION OF THE OBSERVATION PERIOD, I.E. THE
C              NUMBER  NHP  OF ACCEPTED INTEGRATION STEPS IN A PERIOD
C          - COMPUTES ALL THE SEGMENT STEPS BY REPEATEDLY CALLING THE
C              SUBROUTINE  STEP
C          - PERFORMS THE SEGMENT SELECTION BY CALLING THE SUBROUTINE
C               BRASI
C
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
C
C DETERMINE DURATION OF OBSERVATION PERIOD
C (NUMBER OF TIME INTEGRATION STEPS)
C
      KGEN = KGEN+1
      NKGEN = 1
      IF(INHP.EQ.1)NKGEN=
     1    INT(SNGL(DLOG(DBLE(FLOAT(KGEN))+.5D0)/DLOG(2.D0)))+1
      IF(INHP.EQ.2)NKGEN = INT(SNGL(DSQRT(DBLE(FLOAT(KGEN))+.5D0)))
      IF(INHP.EQ.3)NKGEN = KGEN
C
C PERFORM THE REQUIRED NUMBER OF INTEGRATION STEPS
C (FOR ALL TRAJECTORIES)
C
      DO 10 IK = 1,NKGEN
C
C PERFORM A SINGLE INTEGRATION STEP
C (FOR ALL TRAJECTORIES)
C
         CALL STEP(IK)
  10     CONTINUE
C
C MANAGE THE TRAJECTORY BRANCHING PROCESS
C
      CALL BRASI
      RETURN
      END
