      SUBROUTINE STEP(IK)
C
C  STEP  PERFORMS A SINGLE TIME-INTEGRATION STEP FOR EACH ONE OF THE
C  SIMULTANEOUS TRAJECTORIES BY REPEATEDLY CALLING THE SUBROUTINE  SSTEP
C
      DOUBLE PRECISION F
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      DOUBLE PRECISION XID,HID,EPSID,DXID
      DIMENSION XID(100)
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
C
      KTIM = KTIM+1
C
C LOOP ON THE SIMULTANEOUS TRAJECTORY SEGMENTS
      DO 30 ID = 1,NTRAJ
C
C INFORM THE SCALING SUBPROGRAMS (VIA THE COMMON AREA /SCALE/)
C THAT SCALING OPERATIONS ARE TO BE PERFORMED ON SEGMENT  ID .
         CALL SEGSCA(ID)
         F = VCOR(ID)
C
C PERFORM A TIME-INTEGRATION STEP ON SEGMENT  ID .
         KA = KTIM
         NX = NDIM
         DO 10 IX = 1,NX
            XID(IX) = X(IX,ID)
  10        CONTINUE
         HID = H(ID)
         EPSID = EPS(ID)
         DXID = DX(ID)
         IEID = IE(ID)
C
         CALL SSTEP(KA,NX,XID,HID,EPSID,DXID,IEID,F)
C
         DO 20 IX = 1,NX
            X(IX,ID) = XID(IX)
  20        CONTINUE
         H(ID) = HID
         EPS(ID) = EPSID
         DX(ID) = DXID
         IE(ID) = IEID
         VCOR(ID) = F
         VMCOR(ID) = DMIN1(VMCOR(ID),F)
         IF(IK.EQ.1)VMCOR(ID) = F
         IF(KTIM.EQ.1)IE(ID) = 0
  30     CONTINUE
C
      RETURN
      END
